import dk.vajhoej.record.FieldType;
import dk.vajhoej.record.Struct;
import dk.vajhoej.record.StructField;

import static dk.vajhoej.vms.call.VMS.*;

public class MBLK {
    @Struct
    public static class A {
        @StructField(n=0,type=FieldType.INT4)
        private int v;
        @StructField(n=1,type=FieldType.INT4)
        private int b;
        public A(int v) {
            this.v = v;
            this.b = 0; // will be set elsewhere
        }
        public int getV() {
            return v;
        }
        public int getB() {
            return b;
        }
    }
    @Struct
    public static class B {
        @StructField(n=0,type=FieldType.INT4)
        public int v;
        public B(int v) {
            this.v = v;
        }
        public int getV() {
            return v;
        }
    }
    public static void main(String[] args) throws Exception {
        MultiBlock blk = new MultiBlock(new BlockHeader(4, 8), new A(123), new B(456));
        int res = call("MBLKSHR", "TEST", pass(blk).byReference().readOnly());
        System.out.println(res);
    }
}
